package arbolrojonegro;

import java.util.*;
/**
 *  Este programa genera un arbol rojo_negro ordenado por el codigo del objeto 
 * item. Cada nodo contiene un objeto Item, mas un objeto ArrayList para el
 * overflow de los objetos Item repetidos.
*/
class RojoNegroConRep{  
    TreeSet arbol;
    ItemRep itemRep;
    int contOv = 0;
    public void demo02(){
        arbol = new TreeSet<ItemRep>(); // 
        ArrayItems arrayItems = new ArrayItems(20,'R');
        Item item;
        Iterator it = arrayItems.iterator();
        while(it.hasNext()){    //  Recorro ArrayList de items
            item = (Item)it.next(); //  obtengo el corriente
            //  Si no lo consigo incluir en el TreeSet como item unico
            //  lo incluiremos en el overflow
            itemRep = new ItemRep(item);
            if (!arbol.add(itemRep)) overflow(item);
        }
        System.out.println(this);
    }
    
    private void overflow(Item itemPar){   //  tratamiento items duplicados
        Iterator it = arbol.iterator();
        Item itemAux;
        while(it.hasNext()){    //  recorriendo el arbol
            ItemRep itemRep = (ItemRep)it.next(); // Obtengo el objeto del nodo
            itemAux = new Item(itemRep.getItem());  // Obtengo su item
            if(itemAux.compareTo(itemPar) == 0){
                itemRep.aList.add(itemPar);
                contOv++;
            }
        }
    }
    
    public String toString(){
        String auxStr = "Arbol Rojo Negro con repeticiones\n";
        auxStr += "tiene " + arbol.size() + " nodos\n";
        auxStr += "y un overflow de  " + contOv + " items\n[";
        Iterator itArb = arbol.iterator();
        Item itemAux;
        while(itArb.hasNext()){    //  recorriendo el arbol
            ItemRep itemRep = (ItemRep)itArb.next(); // Obtengo el objeto del nodo
            auxStr += itemRep.getItem() + ", ";    //  Obtengo el item
            ArrayList arList = itemRep.getaList();
            Iterator itaList = arList.iterator();
            while(itaList.hasNext()){    //  recorriendo el overflow del nodo
                Item item = (Item)itaList.next(); // Obtengo el item
                auxStr += item + ", ";
            }
            auxStr += "\n";
        }
        auxStr += "]";
        return auxStr;
    }
    
}

