package arritems01;
import java.util.ArrayList;
public class ArrayItems extends ArrayList{
    public ArrayItems(int cap, char tipo){
        super(5); //  Construimos objeto ArrayList con capacidad de 5 objetos
        int auxCod = 0;
	for(int i=0; i<cap-2; i++){ // incluimos solo 3 items 
            switch(tipo){     // dependiendo del tipo de llenado requerido
		case 'A':{    // los haremos en secuencia ascendente
                    auxCod = i*3;
                    break;
		}
		case 'D':{ // o descendente ...
                    auxCod = cap - i;
                    break;
		}
		case 'R':{ // o bien randomicamentente (Al azar)
                    auxCod = (int)(cap*2*Math.random());
		}
            }   //  swith
            add(new Item(auxCod, (float)(cap*10*Math.random())));
	}   //  for
    }   //  ArrayItems
    
    public void demo(){
        System.out.println("Objeto array recin construido");
        System.out.println(this);
        
        System.out.println("Insertamos item en posicin 1");
        add(1, new Item(1, (float)10.3));
        System.out.println(this);

        System.out.println("Agregamos 2 items al final");
        System.out.println("(Incremento capacidad automtico)");
        add(new Item(10, (float)100));
        add(new Item(10, (float)100));
        System.out.println(this);
        
        System.out.println("Removemos el 3er elemento");
        remove(2);
        System.out.println(this);
        
        System.out.println("Insertamos String en posicin 2");
        add(2, new String("Heterogeneo"));
        System.out.println(this);
        System.out.println("Demo terminado!!!");
    }
    
    public static void main(String[] args) {
        ArrayItems array = new ArrayItems(5, 'A');
        array.demo();
    }
}
