package treesettest01;
import java.util.*;
/**
   Este programa genera un arbol rojo_negro ordenado por el codigo del objeto 
   item. Para ello el objeto Item implementa la interfaz Comparable (Y el mtodo
 * compareTo())
*/
public class TreeSetTest01{
    // Definimos atributos
    ArrItems aItem01;
    TreeSet treeSet01;
    
    public void demo01(){
        System.out.println("demo01, generacion");
        //  Generamos un ArrayList de items
        aItem01 = new ArrItems(10,'R');
        System.out.println("El ArrayList aItem01 contiene "+aItem01.size()+" items");
        System.out.println(aItem01);

        //  Generamos TreeSet a partir de ArrayList  
        treeSet01 = new TreeSet(aItem01);   
        System.out.println("El TreeSet treeSet01 contiene "+treeSet01.size()+" items");
        System.out.println(treeSet01);
    }
    
    public void demo02(){
        System.out.println("\ndemo02, altas");
        //  Probamos de incorporarle 5 items ms.
        int contIncl =0;
        for(int i=0;i<5;i++)
            if (treeSet01.add(new Item((int)(10*Math.random()),(float)(100*Math.random()))))
                contIncl++;
        System.out.println("Hemos incluido "+contIncl+" items");
        System.out.println("treeSet01 contiene "+treeSet01.size()+" items");
        System.out.println(treeSet01);
    }

    public void demo03(){
        System.out.println("\ndemo03, pertenencia y bajas");
        //  Verificamos pertenencia de items
        Item item;
        int contBaj =0;
        for(int i=0;i<5;i++){
            item = new Item((int)(10*Math.random()),(float)(100*Math.random()));
            if (treeSet01.contains(item)){
                System.out.println("El item "+item+" ya existe en treeSet01");
                treeSet01.remove(item);
                contBaj++;
            }
            else
                System.out.println("El item "+item+" no existe en treeSet01");
        }
        System.out.println("Hemos excluido "+contBaj+" items");
        System.out.println("treeSet01 contiene ahora "+treeSet01.size()+" items");
        System.out.println(treeSet01);
    }
}

