package treesettest03;

import java.util.*;
/**
 *  Este programa genera un arbol rojo_negro ordenado por el codigo del objeto 
 * item. Cada nodo contiene un objeto Nodo,conteniendo:
 *      Un Objeto Item
 *      Un TreeSet de objetos Stock.
*/
class RojoNegroConArbol{
    TreeSet arbol03;
    Nodo nodo;
    Item item;
    Stock stock;
    public RojoNegroConArbol(){   //  Un constructor muy capaz
       arbol03 = new TreeSet<Nodo>(); // Un arbol tiene nodos (internos u hojas)
       for(int i=0; i<20; i++){     //  Generamos datos source
           nodo = new Nodo();  //  para Nodo
           if(arbol03.add(nodo)){   //  Apareció por primera vez, lo incluimos
                System.out.println("item "+nodo.item+" incluido");
                //  y le incluimos stocks
                for(int j=0;j<10;j++){
                    stock = new Stock();  //  Lo valuamos randomicamente ...
                    if(nodo.stocks.add(stock))
                        System.out.println("                       stock "+stock+" incluido");
                }
           }
       }    //  for
    }   //  metodo RojoNegroConArbol
    
    @Override
    public String toString(){
        String auxStr = "Arbol Rojo Negro con arbol interno, tamaño: "+arbol03.size();
        Nodo nodoAux;
        Iterator itArbol03 = arbol03.iterator();//  Necesitamos recorrer arbol
        while(itArbol03.hasNext()){
            nodoAux = (Nodo)itArbol03.next();
            auxStr+= "\nitem "+nodoAux.item+", sus stocks: ";
            //  y dejemos que el toString retorne lo que tiene el subarbol
            auxStr+=nodoAux.stocks.toString();
        }
        return auxStr;
    }
}

